<?php
session_start();
/*
|---------------------------------------------------|
|				  LICENSE BLOCK START			    |
|---------------------------------------------------|
|			  The Uploader 2.0 - Stable			    |
|---------------------------------------------------|
|													|
| Creators:          Andy94 & Ste_95				|
|  Company:				MegaLab.it					|
|     Site:           www.MegaLab.it                |
|  License:			 Creative Commons				|
| Released:          Semptember, 2009				|
|													|
|---------------------------------------------------|
|				  LICENSE BLOCK END				    |
|---------------------------------------------------|
*/

//Include configuration file, set a variable used for error managing and initialize e-mail text
include("../config.inc.php");
include("../DBHandler.php");
include("../api/notifications.php");
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
	<title>The Uploader 2.0 - Upload</title>
	<!--FAVICON SECTION-->
	<link rel="SHORTCUT ICON" href="<?php echo $main['server_name'] ?>favicon.ico" />
	<!--Metagags section-->
	<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
	<meta name="language" content="English" />
	<meta name="author" content="Andy94 &amp; Ste_95" />
	<meta name="copyright" content="Andy94 &amp; Ste_95 ..::.. MegaLab.it Staff" />
	<meta http-equiv="X-UA-Compatible" content="IE=7" />
	<!--Styles importing-->
	<style type="text/css">
		@import url("<?php echo $main['server_name'] ?>styles/main.css");
		@import url("<?php echo $main['server_name'] ?>styles/index.css");
		@import url("<?php echo $main['server_name'] ?>styles/admin.css");
	</style>
	<!--[if lte IE 6]>
	<link href="iefixes.css" rel="stylesheet" type="text/css" />
	<![endif]-->
	<!--AJAX importing-->
	<script type="text/javascript" src="<?php echo $main['server_name'] ?>ajax/mootools-core.js"></script>
	<script type="text/javascript" src="<?php echo $main['server_name'] ?>ajax/mootools-more.js"></script>
</head>
<body id="js">
	<div>
<?php
$nofile=0;
$max_file_slots=$main['max_file_slots'];
$max=$main['max_file_slots'];
$noselected=0;
$files = "";
$messaggio='Someone uploaded a file in your web space, here are details:<br><br>
Uploader IP: ' . $_SERVER['REMOTE_ADDR'] . '<br>
Operating System and Browser: ' . $_SERVER['HTTP_USER_AGENT'] . '<br><br>';

//Check if upload folder exists (create if not)
if(!is_dir($main['upload_directory'])) {
	mkdir($main['upload_directory']);
}

//Check inserted CAPTCHA
if($main['captcha_upload'] == 1) {
	if($_SESSION['segno'] == "+") {
		$Result = ($_SESSION['primonumero'] + $_SESSION['secondonumero']);
	} else if ($_SESSION['segno'] == "-") {
		$Result = ($_SESSION['primonumero'] - $_SESSION['secondonumero']);
	}
	if($_POST['result'] == '') {
		echo '<h3 class="uploadtext">No result entered.</h3>';
		echo '<p class="buttoncontainer"><input type="button" value="Close windows" class="deletebutton" onclick="window.close();" /></p>';
	} else if(!is_numeric($_POST['result'])){
		echo '<h3 class="uploadtext">Result must be numerical.</h3>';
		echo '<p class="buttoncontainer"><input type="button" value="Close windows" class="deletebutton" onclick="window.close();" /></p>';
	} else if($Result == $_POST['result']){
		$captcha="ok";
	} else {
		echo '<h3 class="uploadtext">The entered captcha is wrong.</h3>';
		echo '<p class="buttoncontainer"><input type="button" value="Close windows" class="deletebutton" onclick="window.close();" /></p>';
		if($main['uploads_log'] == true) {
			mainlog("UPFAIL", "Wrong Captcha", "The entered captcha is wrong. File " . $_GET['filename'] . ".", $_SERVER['REMOTE_ADDR']);
		}
	}
}

//If captcha is ok, start upload process
if($captcha=="ok" OR $main['captcha_upload'] == 0) {
	while ($main['max_file_slots'] > 0) {
	//Check if there is at least one or more file to be uploaded
	if($_FILES['upfile_'.$main['max_file_slots']]['name'] == '') {
		if($noselected == ($max-1)) {
			echo '<h3 class="uploadtext">No file selected.</h3>';
			break;
		} else {
			--$max_file_slots;
			--$main['max_file_slots'];
			++$noselected;
			++$nofile;
			continue;
		}
	}
	//Check if file name is index.php
		if($_FILES['upfile_'.$main['max_file_slots']]['name'] == 'index.php') {
			echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">For security reasons, it is forbidden the upload of index.php files.</h3></p>
			</fieldset>';
			if($main['uploads_log'] == 1) {
				mainlog("UPFAIL", "Upload index.php", "Someone tried to upload an index.php file. The upload has been automatically denied for security reasons.", $_SERVER['REMOTE_ADDR']);
			}
			--$main['max_file_slots'];
			++$nofile;
			continue;
		}
	//Check if file is bigger than the max_file_size directive in the php.ini
		if($_FILES['upfile_'.$main['max_file_slots']]['error'] == '2') {
			echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">The file ' . $_FILES['upfile_'.$main['max_file_slots']]['name'].' exceeds max size allowed by the server.</h3></p>
			</fieldset>';
			if($main['uploads_log'] == 1) {
				mainlog("UPFAIL", "File too big", "Server limitations prevented the file \"".$_FILES['upfile_'.$main['max_file_slots']]['name']."\" to be uploaded.", $_SERVER['REMOTE_ADDR']);
			}
			--$main['max_file_slots'];
			++$nofile;
			continue;
		}
	//Check if file is an empty file
		if($_FILES['upfile_'.$main['max_file_slots']]['size'] == '0') {
			echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">File ' . $_FILES['upfile_'.$main['max_file_slots']]['name'].' is empty and can\'t be uploaded.</h3></p>
			</fieldset>';
			if($main['uploads_log'] == 1) {
				mainlog("UPFAIL", "Upload of empty file", "Ther was an attempt to upload an empty file. Upload has been automatically stopped.", $_SERVER['REMOTE_ADDR']);
			}
			--$main['max_file_slots'];
			++$nofile;
			continue;
		}
	//Check if there isn't a file with the same name yet (it may slow) and if so, don't overwrite it
		if($main['check_duplicates'] == 1 AND $main['files_overwrite'] == 0) {
			$open=opendir($main['upload_directory']);	
			while($file = readdir($open)) {
				if(str_replace(" ", "_", $_FILES['upfile_'.$main['max_file_slots']]['name']) == $file) {
					echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">File ' . $_FILES['upfile_'.$main['max_file_slots']]['name'] . ' can\'t be uploaded because there\'s already a file with the same name.</h3></p>
			</fieldset>';
					--$main['max_file_slots'];
					++$nofile;
					unset($AlreadyExists);
					continue(2);
				}
			}
		}
	//Check if file extension is allowed
		$ext=strtolower(substr(strrchr($_FILES['upfile_'.$main['max_file_slots']]['name'], "."), 1));
		if($main['check_ext'] == true) {
			if(!in_array($ext, $main['allowed_ext'])) {
				echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">File ' . $_FILES['upfile_'.$main['max_file_slots']]['name'] . ' has an invalid extension.</h3></p>
			</fieldset>';
				if($main['uploads_log'] == 1) {
					mainlog("UPFAIL", "Invalid extension", "File " . $_FILES['upfile_'.$main['max_file_slots']]['name'] . " has an invalid extension.", $_SERVER['REMOTE_ADDR']);
				}
				if($main['show_in_upload'] == 1) {
					if(!isset($n)) {
						echo '<p class="pupload">Valid extensions are the following:</p>';	
						foreach($main['allowed_ext'] as $temp) {
							if($n!=0) {
								echo ' | ';
							}
							echo $temp;
							++$n;
						}
					}
				}
				--$main['max_file_slots'];
				++$nofile;
				continue;
				}
			}
	//Check if file name exceed min number of chars
		if($main['check_file_lenght'] == true) {
			$long=strlen($_FILES['upfile_'.$main['max_file_slots']]['name']);
			if($long < $main['min_file_lenght']) {
				echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">File name ' . $_FILES['upfile_'.$main['max_file_slots']]['name'] . ' is shorter than the characters limit setted.</h3></p>
			</fieldset>';
				if($main['uploads_log'] == 1) {
					mainlog("UPFAIL", "File Name too short", "File " . $_FILES['upfile_'.$main['max_file_slots']]['name'] . " has a name too short, of " . $long . " characters.", $_SERVER['REMOTE_ADDR']);
				}
				--$main['max_file_slots'];
				++$nofile;
				continue;
			}
		//Check if file name exceed max number of chars
			if($long > $main['max_file_lenght']) {
				if($main['cut_file_name'] == true) {
					$_FILES['upfile_'.$main['max_file_slots']]["name"]=substr($_FILES['upfile_'.$main['max_file_slots']]['name'], 0, $main['max_file_lenght']-3).'.'.$ext;
				} else {
					echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">File Name ' . $_FILES['upfile_'.$main['max_file_slots']]['name'] . ' exceeds the maximum number of characters.</h3></p>
			</fieldset>';
					if($main['uploads_log'] == 1) {
							mainlog("UPFAIL", "File Name too long", "File " . $_FILES['upfile_'.$main['max_file_slots']]['name'] . " has a name too long, of " . $long . " characters.", $_SERVER['REMOTE_ADDR']);
					}
					--$main['max_file_slots'];
					++$nofile;
					continue;
				}
			}
		}
	//Check if file size is not exceeding the min size
		if($main['check_file_size'] == true) {
			if($_FILES['upfile_'.$main['max_file_slots']]['size'] < $main['min_file_size']) {
				echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">File ' . $_FILES['upfile_'.$main['max_file_slots']]['name'] . ' has a lower size than the minimum one allowed.</h3></p>
			</fieldset>';
				if($main['uploads_log'] == 1) {
					mainlog("UPFAIL", "File too small", "File " . $_FILES['upfile_'.$main['max_file_slots']]['name'] . " has a lower size than the minimum one allowed, of " . $_FILES['upfile_'.$main['max_file_slots']]['size'] . " byte.", $_SERVER['REMOTE_ADDR']);
				}
				--$main['max_file_slots'];
				++$nofile;
				continue;
			}
		//Check if file size is not exceeding the max one
			if($_FILES['upfile_'.$main['max_file_slots']]['size'] > $main['max_file_size']) {
				echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">File ' . $_FILES['upfile_'.$main['max_file_slots']]['name'] . ' exceeds the max size.</h3></p>
			</fieldset>';
				if($main['uploads_log'] == 1) {
					mainlog("UPFAIL", "File too big", "File " . $_FILES['upfile_'.$main['max_file_slots']]['name'] . " has a bigger size than the maximum one allowed, of " . $_FILES['upfile_'.$main['max_file_slots']]['size'] . " byte.", $_SERVER['REMOTE_ADDR']);
				}
				--$main['max_file_slots'];
				++$nofile;
				continue;
			}
		}
	//Rename the file if necessary
		if($main['file_name_keep'] == true) {
			$name=$_FILES['upfile_'.$main['max_file_slots']]["name"];
		} else {
			$name=time()+rand(1, 1000) . '.' . $ext;
		}
	//Replace spaces with underscores
		$name=str_replace(" ", "_", $name);
	//Upload file
		if(is_uploaded_file($_FILES['upfile_'.$main['max_file_slots']]['tmp_name'])) {
			$muovi=move_uploaded_file($_FILES['upfile_'.$main['max_file_slots']]['tmp_name'], $main['upload_directory'].$name);
			if($muovi == false) {
				echo '<fieldset><legend>'.$_FILES['upfile_'.$main['max_file_slots']]['name'].'</legend>
				<p style=\"margin: 0px;\"><h3 class="uploadtext">There was a problem while uploading file ' . $_FILES['upfile_'.$main['max_file_slots']]['name'] . '</h3></p>
			</fieldset>';
				if($main['uploads_log'] == 1) {
					mainlog("UPFAIL", "Error uploading file", "File " . $_FILES['upfile_'.$main['max_file_slots']]['name'] . " can't be moved to the upload directory.", $_SERVER['REMOTE_ADDR']);
				}
				--$main['max_file_slots'];
				++$nofile;
				continue;
			}
			$success=1;
			$files .= "
			<fieldset><legend>".$_FILES['upfile_'.$main['max_file_slots']]['name']."</legend>
				<p style=\"margin: 0px;\"><b>Download Link:</b> ".$main['server_name']."download.php?filename=".$name."</p>
				<p style=\"margin: 0px;\"><b>Direct Download (opens in a new tab):</b> <a href=\"javascript:void(0)\" class=\"filelink\" onclick=\"window.opener.location.replace('../download.php?filename=".$name."')\">Direct Download</a></p>
			</fieldset>
			";
		}
	
	//Get unit of size for the file
	if($_FILES['upfile_'.$main['max_file_slots']]['size'] < 1024) {
		$unit=$_FILES['upfile_'.$main['max_file_slots']]['size'].' B';
	} else if ($_FILES['upfile_'.$main['max_file_slots']]['size'] > 1024 AND $_FILES['upfile_'.$main['max_file_slots']]['size'] < 1048576) {
		$unit=round($_FILES['upfile_'.$main['max_file_slots']]['size']/1024, 2).' KB</td>';
	} else {
		$unit=round($_FILES['upfile_'.$main['max_file_slots']]['size']/1024/1024, 2).' MB</td>';
	}

	//Insert record in the database
	if($main['uploads_log'] == 1) {
		uploadlog(addslashes($name), $_FILES['upfile_'.$main['max_file_slots']]['size'], $ext, $_SERVER['REMOTE_ADDR']);
		}
	if($main['uploads_log'] == 1) {
		mainlog("UPOK", "File uploaded correctly", "File " . addslashes($_FILES['upfile_'.$main['max_file_slots']]['name']) . " has been uploaded successfully.", $_SERVER['REMOTE_ADDR']);
	}
	
	//Send admin email if requested
	$SelectId['query'] = "SELECT id FROM ".$main['table_prefix']."_uploads ORDER BY id DESC LIMIT 0,1";
	$SelectId['execute'] = mysql_query($SelectId['query']) or error("Unable to execute query", mysql_error());
	$SelectId['fetch'] = mysql_fetch_array($SelectId['execute']);
	$messaggio .= 'Download: <a href="' . $main['server_name'] . 'download.php?filename=' .$name . '" target="_blank" title="Download file">' . $name . '</a><br>
	File name:  ' .$name . '<br>
	File size: ' . $unit . '<br>
	File extension: ' . $ext . '<br>
	Upload Date and Time: ' . date("d/m/Y H:i:s") . '<br>
	Delete file: <a href="' . $main['server_name'] . 'admin/ajax/ajaxlinks.php?fileid=' . $SelectId['fetch']['id'] . '" target="_blank" title="Delete file">Delete file</a><br><br>';
		--$main['max_file_slots'];
		if($main['upload_limit'] != 0) {
			++$_SESSION['upload_limit'];
			$_SESSION['time_upload_limit']=time();
		}
	}
	echo $files;

	if($nofile !== ($max+1) AND $success == 1) {
		if($main['upload_email'] == true) {
			$email_to = "";
			$SendMail['query'] = "SELECT id, mail FROM " . $main['table_prefix'] . "_admins WHERE activated=1";
			$SendMail['execute'] = mysql_query($SendMail['query']) or error("Unable to execute query", mysql_error());
			$n_recipients=0;
			while ($SendMail['fetch'] = mysql_fetch_array($SendMail['execute'])) {
				if($n_recipients == mysql_num_rows($SendMail['execute'])-1) {
					$email_to .= $SendMail['fetch']['mail'];
				} else {
					$email_to .= $SendMail['fetch']['mail'] . ', ';
					++$n_recipients;
				}
			}
			$messaggio .= 'Thank you for choosing The Uploader 2.0.';
			$header = "From: " . $main['email_from'] . "\n";
			$header .= "MIME-Version: 1.0\n";
			$header .= "Content-Type: text/html; charset=\"iso-8859-1\"\n";
			$header .= "Content-Transfer-Encoding: 7bit\n\n";
			mail($email_to, $main['email_subject'], $messaggio, $header);
		}
	}
	if($success == 1){
		echo '<p class="buttoncontainer"><input type="button" value="Close window" class="deletebutton" onclick="window.close(); window.opener.reload();" /></p>';
	} else {
		echo '<p class="buttoncontainer"><input type="button" value="Close window" class="deletebutton" onclick="window.close();" /></p>';
	}
}
?>
	</div>
</body>
</html>
